<?php

/**
 * @file
 * Contains \Drupal\intense\IntenseManager.
 */

namespace Drupal\intense;

use Drupal\Core\Template\Attribute;
use Drupal\Component\Utility\NestedArray;

/**
 * Defines an intense manager.
 */
class IntenseManager {

  /**
   * Modifies attributes for both theme_intense() and theme_slick_image() once.
   */
  public static function buildAttributes(array &$variables) {
    $item       = $variables['item'];
    $settings   = &$variables['settings'];
    $attributes = new Attribute();

    $attributes->addClass('intense');
    $attributes->setAttribute('data-image', $settings['image_url']);
    if (!empty($settings['caption']) && !empty($settings['intense_caption'])) {
      foreach (array_filter($settings['caption']) as $caption) {
        if (!empty($item->$caption)) {
          $data = $caption == 'alt' ? 'caption' : 'title';
          $attributes->setAttribute('data-' . $data, $item->$caption);
        }
      }
    }

    $settings['icon'] = [];
    if ($settings['intense_icon']) {
      $attributes->addClass('intense--icon');
      $settings['icon']['#markup'] = '<span' . $attributes . '></span>';
    }
    else {
      $variables['image']['#attributes'] = NestedArray::mergeDeep($variables['image']['#attributes'], $attributes->toArray());
    }
  }

}
